//
// Created by yelv1 on 24-12-30.
//

#include "usart.h"

/**
 * @brief  configure the RS485(MAX13487) driver
 * @param  none
 * @retval none
 */
void rs485_config(void)
{
    rcu_periph_clock_enable(USART_GPIO_RCU);
    rcu_periph_clock_enable(USART_RCU);

    gpio_af_set(USART_GPIO_PORT, GPIO_AF_1, USART_TX_PIN | USART_RX_PIN | RS485_EN_PIN);

    /* configure USART Tx&Rx as alternate function push-pull */
    gpio_mode_set(USART_GPIO_PORT, GPIO_MODE_AF, GPIO_PUPD_PULLUP, USART_TX_PIN | USART_RX_PIN);
    gpio_output_options_set(USART_GPIO_PORT, GPIO_OTYPE_PP, GPIO_OSPEED_10MHZ, USART_TX_PIN | USART_RX_PIN);

    /* configure RS485 EN Pin */
    gpio_mode_set(USART_GPIO_PORT, GPIO_MODE_AF, GPIO_PUPD_NONE, RS485_EN_PIN);
    gpio_output_options_set(USART_GPIO_PORT, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, RS485_EN_PIN);
    // gpio_bit_write(RS485_GPIO_PORT, RS485_EN_PIN, SET);

    /* USART configure */
    usart_deinit(USART_PHY);
    usart_baudrate_set(USART_PHY, USART_PHY_BAUDRATE);
    // usart_parity_config(RS485_PHY, USART_PM_NONE);
    // usart_word_length_set(RS485_PHY, USART_WL_8BIT);
    // usart_stop_bit_set(RS485_PHY, USART_STB_1BIT);
    usart_receive_config(USART_PHY, USART_RECEIVE_ENABLE);
    usart_transmit_config(USART_PHY, USART_TRANSMIT_ENABLE);

    usart_driver_assertime_config(USART_PHY, 0x01);
    usart_driver_deassertime_config(USART_PHY, 0x01);

    // usart_depolarity_config(USART0, USART_DEP_HIGH);
    // usart_depolarity_config(USART0, USART_DEP_LOW);

    usart_rs485_driver_enable(USART_PHY);
    usart_enable(USART_PHY);

    nvic_irq_enable(USART0_IRQn, 0);
    usart_interrupt_enable(USART_PHY, USART_INT_RBNE);
    usart_interrupt_enable(USART_PHY, USART_INT_IDLE);
}